%% deref(X, Y): X = Y, but Y is dereferenced.
deref(X, DX) :-
	X =.. L,
	DX =.. L.

%% Call clpfd:dispatch_global_fast after dereferencing input arguments.
clpfd_dispatch_global_fast(Constraint, State0, State, Actions, Global) :-
	deref(Constraint, DConstraint),
	deref(State0, DState0),
	deref(Global, DGlobal),
	clpfd:dispatch_global_fast(DConstraint, DState0, State, Actions, DGlobal).
